#include "config.h"
#include "defines.h"
#include "fdbuf.h"
#include "itoa.h"
#include <dirent.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <time.h>
#include <unistd.h>

fdobuf f_out(1);

#define fail(X) do{ f_out.writeln(X); return 1; }while(0)

int main(int, char*[])
{
  if(chdir(QUEUE_MSG_DIR))
    fail("Cannot change directory to queue.");
  DIR* dir = opendir(QUEUE_MSG_DIR);
  if(!dir)
    fail("Cannot open queue directory.");
  struct dirent* entry;
  while((entry = readdir(dir)) != 0) {
    const char* name = entry->d_name;
    if(name[0] == '.')
      continue;
    time_t time = atoi(name);
    char timebuf[100];
    strftime(timebuf, 100, "%Y-%m-%d %H:%M:%S  ", localtime(&time));
    f_out.write(timebuf);
    struct stat statbuf;
    if(stat(name, &statbuf) == -1) 
      f_out.write("?????");
    else
      f_out.write(itoa(statbuf.st_size));
    f_out.writeln(" bytes");
  }
  closedir(dir);
  return 0;
}
